﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CySoft.Collections.Geometry
{
	public abstract class WeightedKDTreeBase<T> : KDTree<T> 
	{
		protected double[] _weights;

		protected WeightedKDTreeBase(int dimensions, double[] weights, int? sizeLimit)
			: base(dimensions, sizeLimit)
		{
			_weights = weights;
		}

		protected override double GetAxisWeightHint(int i)
		{
			return _weights[i];
		}

	}
}
