﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using CySoft.Collections.Geometry;

namespace KdTreeTestProject
{
	[TestClass]
	public class DistanceFunctionTests
	{
		[TestMethod]
		public void SquareEuclidian()
		{
			var sut = SquareEuclideanDistance.Instance;
			Assert.AreEqual(25.0, sut.Distance(new double[] { 10, 20 }, new double[] { 14, 23 }));
		}

		[TestMethod]
		public void Manhattan()
		{
			var sut = ManhattanDistance.Instance;
			Assert.AreEqual(7.0, sut.Distance(new double[] { 10, 20 }, new double[] { 14, 23 }));
		}

		[TestMethod]
		public void Chebyshev()
		{
			var sut = ChebyshevDistance.Instance;
			Assert.AreEqual(4.0, sut.Distance(new double[] { 10, 20 }, new double[] { 14, 23 }));
		}

		[TestMethod]
		public void SquareEuclidianInverse()
		{
			var sut = SquareEuclideanDistance.Instance;
			Assert.AreEqual(25.0, sut.Distance(new double[] { 14, 23 }, new double[] { 10, 20 }));
		}

		[TestMethod]
		public void ManhattanInverse()
		{
			var sut = ManhattanDistance.Instance;
			Assert.AreEqual(7.0, sut.Distance(new double[] { 14, 23 }, new double[] { 10, 20 }));
		}

		[TestMethod]
		public void ChebyshevInverse()
		{
			var sut = ChebyshevDistance.Instance;
			Assert.AreEqual(4.0, sut.Distance(new double[] { 14, 23 }, new double[] { 10, 20 }));
		}
	}
}
